=== debian/changelog ===
ros-eloquent-slam-toolbox (2.1.1-1bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Steve Macenski <stevenmacenski@gmail.com>  Wed, 04 Mar 2020 22:16:34 -0000
